package pep;
import java.io.*;
import java.util.*;

/**This class concatenates individual participant data files into one large
 * dataset called Dataset.txt. It also encodes previous response times and
 * previous accuracy. */

public class Concat {
 //----------VARIABLES--------------------------------------------------
 /**file name*/              static String fileName;
 /**number of subjects*/     static int nSubjects = Main.numSubjects;
 /**number of variables*/    static int nVariables = Main.numPerVar.length;
 /**number of conditons*/    static int[] nPerVar = Main.numPerVar;
 //---------------------------------------------------------------------
 /**response time*/          static int rt;
 /**previous response time*/ static int n1rt;
 /**accuracy*/               static int accuracy;
 /**previous accuracy*/      static int n1acc;
 /**distracter number*/      static int dist = 999;
 /**target number*/          static int targ = 999;

 /**Get data from each participant.*/
 public static void main(String[] args){
  for(int i=1; i<=nSubjects; i++){
   n1rt = 99999; n1acc = 999;
   getData(i);
  }
 }

 public static void getData(int i){
  BufferedReader in = null;
  FileOutputStream out = null;
  PrintStream p = null;
  StringTokenizer tokenizer = null;

  //open input and output streams
  try{
   fileName = new String("out"+i+".txt");
   in = new BufferedReader(new FileReader(fileName));
   if(i>1) out = new FileOutputStream("Dataset.txt", true);
   else out = new FileOutputStream("Dataset.txt");
   p = new PrintStream(out);
  }
  catch(Exception e){
   System.out.println("Error setting input and output streams.");
  }

  //read first trial
  try{
   tokenizer = new StringTokenizer(in.readLine());
  }
  catch(Exception e){
   System.out.println("No data in file.");
  }

  while(in!=null){
   try{
    p.print(tokenizer.nextToken()+"\t"); //subject
    p.print(tokenizer.nextToken()+"\t"); //response
    targ = Integer.parseInt(tokenizer.nextToken()); //target
    p.print(targ+"\t");
    for(int j=0; j<Main.numDistracters.length; j++){
     dist = Integer.parseInt(tokenizer.nextToken()); //distracter
     p.print(dist+"\t");
    }
    for(int n=0; n<nVariables; n++){
     p.print(tokenizer.nextToken()+"\t"); //variables
    }
    p.print(tokenizer.nextToken()+"\t"); //correct response
    rt = Integer.parseInt(tokenizer.nextToken());
    accuracy = Integer.parseInt(tokenizer.nextToken());
    p.print(rt+"\t"+accuracy+"\t");

    //print previous RT and accuracy
    if(n1rt==99999) p.println(" \t \t");
    else p.println(n1rt+"\t"+n1acc+"\t");

    //set previous rt and accuracy for next trial
    n1rt = rt; n1acc = accuracy;

    //read next trial
    String tempString = new String(in.readLine());
    //check for END_OF_FILE then send to tokenizer
    if(tempString.equals("END_OF_FILE")) in = null;
    else tokenizer = new StringTokenizer(tempString);
   }
   catch(Exception e3){
    in = null;
    System.out.println("No END_OF_FILE in data file.");
   }
  }

  //close input and output streams
  try{
   p.close(); out.close();
  }
  catch(Exception e2){
   System.out.println("Error closing input and output streams");
  }
 }
}
