/**Parallel Episodic Processing (PEP) Model
 * Version 1.2.0
 * James R. Schmidt, Universiteit Gent
 * Fonds Wetenschappelijk Onderzoek - Vlaanderen (FWO)*/

package pep;

/**This is the Main class in which the model variables need to be
 * defined (in the VARIABLES section of the code).*/
public class Main{
 //----------VARIABLES------------------------------------------
 /**DataSet source*/
 private static String source = new String("hLowPC.txt");
 /**number of subjects*/                static int numSubjects = 1000;
 /**random with replacement?*/          static boolean isReplace = false;
 /**number of blocks per subject*/      private static int numBlocks = 1;
 /**number of trials (no replacement)*/ static int numSamples = 0;
 /**number of responses*/               static int numResponses = 6;
 /**number of targets*/                 static int numTargets = 6;
 /**target bias*/                       static double targBias = .9;
 /**target signal*/                     static double targSignal = .9;
 /**number of distracters per set*/     static int[] numDistracters = {6};
 /**distracter bias*/                   static double[] distBias = {.9};
 /**distracter signal*/                 static double[] distSignal = {.9};
 /**Set 1 distracter conflict*/         static boolean isConflict = true;
 /**number of conditons per variable*/  static int[] numPerVar = {2,2,2};
 //-------------------------------------------------------------

 /**For each participant, the main method creates a DataSet, runs it
  * with RunTime (the guts of the model), and then generates condition
  * means with DataAnalysis.*/
 public static void main(String[] args){
  for(int y=0; y<numSubjects; y++){
   new DataSet(source,numBlocks,isReplace,numSamples);
   new RunTime(y+1);
   System.out.println(""+(y+1)+" of "+numSubjects+" subjects complete...");
  }
  DataAnalysis.main(new String[0]);
  System.out.println("Data analysis complete...");
  Concat.main(new String[0]);
  System.out.println("Data files concatenated...");
 }
}